note
   description: "Example of the use of the Observer pattern"

class MAIN

create make

---------------------------
feature -- Creation

make
  -- Creation and initialization
  local
    clock_timer : CLOCK_TIMER
    analog_clock : ANALOG_CLOCK
    digital_clock : DIGITAL_CLOCK
    i : INTEGER
    tick_interval : INTEGER
  do
  	tick_interval := 4
    create clock_timer.make(33333, tick_interval)
    create analog_clock.make(clock_timer)
    create digital_clock.make(clock_timer)
    print("Display the analog and digital clock times for three 'tick' times%N"
         + "that corresponds to " + tick_interval.out + " seconds a tick.%N%N")
    from i := 1 until i > 3
    loop
      clock_timer.tick -- Make the clock_timer tick
      print("%N")
      i := i + 1
    end
  end

end
